(function () {
    var URL = window.UEDITOR_HOME_URL || getUEBasePath();
    window.UEDITOR_CONFIG = {
        //为编辑器实例添加一个路径，这个不能被注释
        UEDITOR_HOME_URL: URL
        //工具栏上的所有的功能按钮和下拉框，可以在new编辑器的实例时选择自己需要的从新定义       
        , toolbars: []
        ,iframeCssUrl: 'noteeditor.css' //给编辑器内部引入一个css文件
        ,imagePopup:false      //图片操作的浮层开关，默认打开
        //粘贴只保留标签，去除标签所有属性
        ,retainOnlyLabelPasted: false
        ,pasteplain:true//是否默认为纯文本粘贴。false为不使用纯文本粘贴，true为使用纯文本粘贴
        //启用自动保存
        ,enableAutoSave :false
        ,imageScaleEnabled :false //启用图片拉伸缩放
        ,wordCount :false//是否开启字数统计
        //是否启用元素路径，默认是显示
        ,elementPathEnabled:false
        //打开右键菜单功能
        ,enableContextMenu: false
        ,initialFrameWidth:491  //初始化编辑器宽度,默认1000
        ,initialFrameHeight :485//初始化编辑器高度,默认320

    };

    function getUEBasePath(docUrl, confUrl) {

        return getBasePath(docUrl || self.document.URL || self.location.href, confUrl || getConfigFilePath());

    }

    function getConfigFilePath() {

        var configPath = document.getElementsByTagName('script');

        return configPath[ configPath.length - 1 ].src;

    }

    function getBasePath(docUrl, confUrl) {

        var basePath = confUrl;


        if (/^(\/|\\\\)/.test(confUrl)) {

            basePath = /^.+?\w(\/|\\\\)/.exec(docUrl)[0] + confUrl.replace(/^(\/|\\\\)/, '');

        } else if (!/^[a-z]+:/i.test(confUrl)) {

            docUrl = docUrl.split("#")[0].split("?")[0].replace(/[^\\\/]+$/, '');

            basePath = docUrl + "" + confUrl;

        }

        return optimizationPath(basePath);

    }

    function optimizationPath(path) {

        var protocol = /^[a-z]+:\/\//.exec(path)[ 0 ],
            tmp = null,
            res = [];

        path = path.replace(protocol, "").split("?")[0].split("#")[0];

        path = path.replace(/\\/g, '/').split(/\//);

        path[ path.length - 1 ] = "";

        while (path.length) {

            if (( tmp = path.shift() ) === "..") {
                res.pop();
            } else if (tmp !== ".") {
                res.push(tmp);
            }

        }

        return protocol + res.join("/");

    }

    window.UE = {
        getUEBasePath: getUEBasePath
    };

})();
